Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## oracle.ifs.fdk.core
Class CoreWorkspaceManager

    java.lang.Object
      oracle.ifs.fdk.impl.WorkspaceManagerImpl
          oracle.ifs.fdk.core.CoreWorkspaceManager

All Implemented Interfaces:
  java.rmi.Remote, WorkspaceManager

    public class CoreWorkspaceManager

extends WorkspaceManagerImpl

Implementation of the WorkspaceManager interface.

See Also:
  `WorkspaceManager`

Constructor Summary
`CoreWorkspaceManager()`
`CoreWorkspaceManager(FdkSession session)`

Method Summary
`Item` | `createPersonalWorkspace(NamedValue[] def, AttributeRequest[] attributes)` Creates a new personal workspace for the current user.
`Item` | `createPersonalWorkspaceForUser(long userId, NamedValue[] def, AttributeRequest[] attributes)` Creates a new personal workspace for the given user.
`Item` | `createWorkspace(long target, NamedValue[] workflowParams, NamedValue[] def, AttributeRequest[] attributes)` Creates a new workspace or a request.
`void` | `deleteWorkspace(long id, NamedValue[] def)` Deletes a workspace.
`protected FdkSessionImpl` | `getConnectedSession()` Return the web service session.
`protected boolean` | `isWebServiceCall()` Returns `true` if the current call was made from a web services client.
`Item` | `joinWorkspace(long id, long[] requestedRoles, NamedValue[] wfParams, AttributeRequest[] attributes)` Requests to join a JoinableWorkspace.
`Item[]` | `listJoinableWorkspaces(NamedValue[] options, AttributeRequest[] attrs)` Lists workspaces that can be joined via request.
`protected NamedValue[]` | `login(FdkCredential c, NamedValue[] options, AttributeRequest[] userAttributes)` Internal login method used by web services login managers.
`void` | `referenceTypes(TypeReference ref)` Dummy web service method to create a reference to data types used in the web services to insure that they are defined in the WSDL.
`Item` | `updateWorkspace(long id, NamedValue[] def, AttributeRequest[] attributes)` Updates an existing Workspace.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### CoreWorkspaceManager

    public CoreWorkspaceManager()

### CoreWorkspaceManager

    public CoreWorkspaceManager(FdkSession session)

Method Detail

### createWorkspace

    public Item createWorkspace(long target,
                                NamedValue[] workflowParams,
                                NamedValue[] def,
                                AttributeRequest[] attributes)
                         throws FdkException

  Description copied from interface: `WorkspaceManager`
  Creates a new workspace or a request.

  If workflow is enabled AND 'CreateWorkspace' is workflow enabled, then an item of type 'REQUEST' is returned.

  Otherwise, returns the created Workspace. can return null if the user ends up not having the ability to access the new Workspace.

  Clients should check the type of the Item returned and act accordingly (If it's a request, inform user the request needs to be approved before the workspace can be created.).

  The workspace definition also takes parameters for setting various configuration categories, including SECURITY_CONFIGURATION, VERSIONING_CONFIGURATION, RECORD_CONFIGURATION, and CATEGORY_CONFIGURATION. See the below pattern for SECURITY_CONFIGURATION and the Javadoc for the respective xxxManager.setxxxConfiguration methods.

  To set a WORKFLOW_CONFIGURATION, use the patterns with Options.WORKFLOW_CONFIGURATION_DEFINITION as the top-level NamedValue, and add a NamedValue with Attributes.WORKFLOW_CONFIGURATION_OPERATION to specify the operation. Multiple WORKFLOW_CONFIGURATION_DEFINITIONs may be specified, each with a unique WORKFLOW_CONFIGURATION_OPERATION.

  Parameters:
    `target` - the parent of the new workspace.
    `workflowParams` - the parameters (name/value) needed to start workflow.
    `def` - attributes for the Workspace.
    - notation: {Attribute name, Attribute type}
    - {Attributes.NAME, String}
    - {Attributes.DESCRIPTION, String}
    - {Attributes.JOINABLE, Boolean}
    - {Attributes.SECURITY_CONFIGURATION, NamedValue[]}
      where the attributes are:
      - {Attributes.GRANTS, NamedValueSet[]}
        where each row corresponds to a grant whose attributes are:
        - {Attributes.GRANTEE, Long}
        - {Attributes.ROLES, long[]}
        - {Attributes.PROPAGATING, Boolean}
    `attributes` - requested attributes for each item, or null.
  Returns:
    an Item of type REQUEST or WORKSPACE, or null.
  Throws:
    `FdkException` - if the operation fails.

### createPersonalWorkspace

    public Item createPersonalWorkspace(NamedValue[] def,
                                        AttributeRequest[] attributes)
                                 throws FdkException

  Description copied from interface: `WorkspaceManager`
  Creates a new personal workspace for the current user.

  Parameters:
    `def` - attributes for the workspace:
    - notation: {Attribute name, Attribute type}
    - (none)
    `attributes` - requested attributes for each item, or null.
  Returns:
    the new personal Workspace.
  Throws:
    `FdkException` - if the operation fails.

### createPersonalWorkspaceForUser

    public Item createPersonalWorkspaceForUser(long userId,
                                               NamedValue[] def,
                                               AttributeRequest[] attributes)
                                        throws FdkException

  Description copied from interface: `WorkspaceManager`
  Creates a new personal workspace for the given user.

  Can return null if the creator ends up not having the ability to access the new Workspace.

  Parameters:
    `userId` - the ID of the user.
    `def` - attributes for the workspace:
    - notation: {Attribute name, Attribute type}
    - (none)
    `attributes` - requested attributes for each item, or null.
  Returns:
    the new personal Workspace, or null.
  Throws:
    `FdkException` - if the operation fails.

### updateWorkspace

    public Item updateWorkspace(long id,
                                NamedValue[] def,
                                AttributeRequest[] attributes)
                         throws FdkException

  Description copied from interface: `WorkspaceManager`
  Updates an existing Workspace.

  Parameters:
    `id` - the ID of the existing Workspace.
    `def` - attributes to update:
    - notation: {Attribute name, Attribute type}
    - {Attributes.NAME, String}
    - {Attributes.DESCRIPTION, String}
    - {Attributes.JOINABLE, Boolean}
    `attributes` - requested attributes for each item, or null.
  Returns:
    the updated Workspace.
  Throws:
    `FdkException` - if the operation fails.

### deleteWorkspace

    public void deleteWorkspace(long id,
                                NamedValue[] def)
                         throws FdkException

  Description copied from interface: `WorkspaceManager`
  Deletes a workspace.

  Parameters:
    `id` - the ID of the existing workspace.
    `def` - attributes for the workspace.
  Throws:
    `FdkException` - if the operation fails.

### listJoinableWorkspaces

    public Item[] listJoinableWorkspaces(NamedValue[] options,
                                         AttributeRequest[] attrs)
                                  throws FdkException

  Description copied from interface: `WorkspaceManager`
  Lists workspaces that can be joined via request. Note that the NAME attribute is a name filter; database and Windows wildcards (_?%*) accepted.

  Parameters:
    `options` - Options on the retrieved list. Valid options are:
    - notation: {Attribute name, Attribute type}
    - {Attributes.NAME, String}
    - {Options.PRIMARY_SORT_ATTRIBUTE, String}
    - {Options.PRIMARY_SORT_DIRECTION, Boolean}
    - {Options.SECONDARY_SORT_ATTRIBUTE, String}
    - {Options.SECONDARY_SORT_DIRECTION, Boolean}
    If an attribute name is specified with no direction, ascending is the default. Attribute names must be valid attributes and must return values that implement Comparable.
    `attrs` - attributes to return. Note that the DESCRIPTION attribute will always return null on these objects. To get the description of the Workspace, use the JOINABLE_WORKSPACE_DESCRIPTION attribute.
  Returns:
    An array of items representing joinable workspaces.
  Throws:
    `FdkException` - if the operation fails.

### joinWorkspace

    public Item joinWorkspace(long id,
                              long[] requestedRoles,
                              NamedValue[] wfParams,
                              AttributeRequest[] attributes)
                       throws FdkException

  Description copied from interface: `WorkspaceManager`
  Requests to join a JoinableWorkspace.

  Parameters:
    `id` - the ID of the JoinableWorkspace to join.
    `requestedRoles` - array of requested role IDs.
    `wfParams` - the parameters (name/value) used to start workflow the workflow parameter IFS_ECM_WORKFLOW_JUSTIFICATION must be supplied for this call to succeed.
    `attributes` - requested attributes from the resulting request.
  Returns:
    the request; upon approval the user will be added.
  Throws:
    `FdkException` - if the operation fails.

### isWebServiceCall

    protected final boolean isWebServiceCall()

  Returns `true` if the current call was made from a web services client. This check can be made by any subclasses in order to determine functionality and restrictions based on the originating call. This feature should be used lightly and only where really necessary as this is not an idea way of implementing business logic.

### referenceTypes

    public void referenceTypes(TypeReference ref)

  Dummy web service method to create a reference to data types used in the web services to insure that they are defined in the WSDL.

### login

    protected final NamedValue[] login(FdkCredential c,
                                       NamedValue[] options,
                                       AttributeRequest[] userAttributes)
                                throws FdkException

  Internal login method used by web services login managers.

  Throws:
    `FdkException`

### getConnectedSession

    protected final FdkSessionImpl getConnectedSession()
                                                throws FdkException

  Return the web service session. The return value is guaranteed to be non-null and to represent a connected session. If the client is not authenticated an FdkException is thrown.

  Throws:
    `FdkException`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD